diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/MnTableCreator.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/MnTableCreator.java
index 7f2f7907d0..f53935785d 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/MnTableCreator.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/MnTableCreator.java
@@ -23,19 +23,19 @@ public class MnTableCreator extends TableCreator {
 	private boolean secondTableInKey;
 	
 	public static MnTableCreator NewMnInstance(String stepName, String firstTableName, String secondTableName, boolean includeAudTable){
-		MnTableCreator result = new MnTableCreator(stepName, firstTableName, null, secondTableName, null, new String[]{}, new String[]{}, null, null, includeAudTable, false, true, false, false);
+		MnTableCreator result = new MnTableCreator(stepName, firstTableName, null, secondTableName, null, new String[]{}, new String[]{}, null, null, includeAudTable, false, true, false, false, false);
 		return result;
 	}
 	
 	public static MnTableCreator NewMnInstance(String stepName, String firstTableName, String firstTableAlias, String secondTableName, String secondTableAlias, boolean includeAudTable, boolean hasSortIndex, boolean secondTableInKey){
-		MnTableCreator result = new MnTableCreator(stepName, firstTableName, firstTableAlias, secondTableName, secondTableAlias, new String[]{}, new String[]{}, null, null, includeAudTable, hasSortIndex, secondTableInKey, false, false);
+		MnTableCreator result = new MnTableCreator(stepName, firstTableName, firstTableAlias, secondTableName, secondTableAlias, new String[]{}, new String[]{}, null, null, includeAudTable, hasSortIndex, secondTableInKey, false, false, false);
 		return result;
 	}
 
 	
 	protected MnTableCreator(String stepName, String firstTableName, String firstTableAlias, String secondTableName, String secondTableAlias, String[] columnNames, String[] columnTypes,
-			List<Object> defaultValues, List<Boolean> isNull, boolean includeAudTable, boolean hasSortIndex, boolean secondTableInKey, boolean includeCdmBaseAttributes, boolean includeIdentifiableEntity) {
-		super(stepName, firstTableName + "_" + secondTableName, Arrays.asList(columnNames), Arrays.asList(columnTypes), defaultValues, isNull,	new ArrayList<String>(), includeAudTable, includeCdmBaseAttributes, includeIdentifiableEntity);
+			List<Object> defaultValues, List<Boolean> isNull, boolean includeAudTable, boolean hasSortIndex, boolean secondTableInKey, boolean includeCdmBaseAttributes,boolean includeAnnotatableEntity, boolean includeIdentifiableEntity) {
+		super(stepName, firstTableName + "_" + secondTableName, Arrays.asList(columnNames), Arrays.asList(columnTypes), defaultValues, isNull,	new ArrayList<String>(), includeAudTable, includeCdmBaseAttributes, includeAnnotatableEntity, includeIdentifiableEntity);
 		this.firstTableName = firstTableName;
 		this.secondTableName = secondTableName;
 		this.firstTableAlias = (firstTableAlias != null )? firstTableAlias : firstTableName ;
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/SchemaUpdaterStepBase.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/SchemaUpdaterStepBase.java
index dd265798f9..209734a855 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/SchemaUpdaterStepBase.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/SchemaUpdaterStepBase.java
@@ -17,6 +17,7 @@ import java.util.UUID;
 
 import org.apache.commons.lang.StringUtils;
 import org.apache.log4j.Logger;
+import org.joda.time.DateTime;
 
 import eu.etaxonomy.cdm.common.monitor.IProgressMonitor;
 import eu.etaxonomy.cdm.database.DatabaseTypeEnum;
@@ -32,10 +33,12 @@ public abstract class SchemaUpdaterStepBase<T extends SchemaUpdaterStepBase<T>>
 	private static final Logger logger = Logger.getLogger(SchemaUpdaterStepBase.class);
 	
 	protected String stepName;
+
+	private boolean ignoreErrors;
 		
 	
 //************************ CONSTRUCTOR ***********************************/
-	
+
 	protected SchemaUpdaterStepBase(String stepName){
 		this.setStepName(stepName);
 	}
@@ -109,6 +112,27 @@ public abstract class SchemaUpdaterStepBase<T extends SchemaUpdaterStepBase<T>>
 	public List<ISchemaUpdaterStep> getInnerSteps(){
 		return new ArrayList<ISchemaUpdaterStep>();
 	}
+	
+	@Override
+	public boolean isIgnoreErrors() {
+		return ignoreErrors;
+	}
+	
+	
+	@Override
+	public void setIgnoreErrors(boolean ignoreErrors) {
+		this.ignoreErrors = ignoreErrors;
+	}
+	
+
+	/**
+	 * Returns a time string with date and time (without millis) that 
+	 * can be used as a time string for database insert and update
+	 * @return
+	 */
+	protected String getNowString() {
+		return DateTime.now().toString("YYYY-MM-dd HH:mm:ss");
+	}
 
 	@Override
 	public String toString(){
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/SimpleSchemaUpdaterStep.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/SimpleSchemaUpdaterStep.java
index 2af4e77efe..d2c4bd5e4a 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/SimpleSchemaUpdaterStep.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/SimpleSchemaUpdaterStep.java
@@ -13,6 +13,7 @@ import java.sql.SQLException;
 import java.util.HashMap;
 import java.util.Map;
 
+import org.apache.commons.lang.StringUtils;
 import org.apache.log4j.Logger;
 
 import eu.etaxonomy.cdm.common.monitor.IProgressMonitor;
@@ -26,50 +27,136 @@ import eu.etaxonomy.cdm.database.ICdmDataSource;
  *
  */
 public class SimpleSchemaUpdaterStep extends SchemaUpdaterStepBase<SimpleSchemaUpdaterStep> implements ISchemaUpdaterStep, ITermUpdaterStep{
-	@SuppressWarnings("unused")
 	private static final Logger logger = Logger.getLogger(SimpleSchemaUpdaterStep.class);
 	
 	private Map<DatabaseTypeEnum, String> queryMap = new HashMap<DatabaseTypeEnum, String>();
+	private Map<DatabaseTypeEnum, String> auditQueryMap = new HashMap<DatabaseTypeEnum, String>();
 	
+	private boolean includeAudit = false;
+//	private String tableName;
 	
 // *************************** FACTORY ********************************/
 	
+	/**
+	 * @deprecated use  {@link #NewInstance(String, String)}, 
+	 * {@link #NewAuditedInstance(String, String, boolean, String)}, 
+	 * or {@link #NewExplicitAuditedInstance(String, String, String)} instead
+	 */
+	@Deprecated
 	public static SimpleSchemaUpdaterStep NewInstance(String stepName, String defaultQuery){
-		return new SimpleSchemaUpdaterStep(stepName, defaultQuery);
+		return new SimpleSchemaUpdaterStep(stepName, defaultQuery, false, null, null);
+	}
+	
+	public static SimpleSchemaUpdaterStep NewNonAuditedInstance(String stepName, String defaultQuery){
+		return new SimpleSchemaUpdaterStep(stepName, defaultQuery, false, null, null);
+	}
+
+	public static SimpleSchemaUpdaterStep NewAuditedInstance(String stepName, String defaultQuery, String nonAuditedTableName){
+		boolean audit = StringUtils.isNotBlank(nonAuditedTableName);
+		return new SimpleSchemaUpdaterStep(stepName, defaultQuery, audit, nonAuditedTableName, null);
+	}
+
+	public static SimpleSchemaUpdaterStep NewExplicitAuditedInstance(String stepName, String defaultQuery, String defaultQueryForAuditedTables){
+		boolean audit = StringUtils.isNotBlank(defaultQueryForAuditedTables);
+		return new SimpleSchemaUpdaterStep(stepName, defaultQuery, audit, null, defaultQueryForAuditedTables);
 	}
+
 	
 //************************ CONSTRUCTOR ***********************************/
-	private SimpleSchemaUpdaterStep(String stepName, String defaultQuery){
+	private SimpleSchemaUpdaterStep(String stepName, String defaultQuery, boolean includeAudit, String tableName, String defaultQueryForAuditedTables){
 		super(stepName);
+		this.includeAudit = includeAudit;
 		queryMap.put(null, defaultQuery);
+		
+		if (includeAudit){
+			if (StringUtils.isNotBlank(defaultQueryForAuditedTables)){
+				auditQueryMap.put(null, defaultQueryForAuditedTables);
+			}else if (StringUtils.isNotBlank(tableName)){
+				setDefaultAuditing(tableName);
+			}
+		}
 	}
 	
 // *************************** INVOKE *****************************	
+
+
 	
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.database.update.SchemaUpdaterStepBase#invoke(eu.etaxonomy.cdm.database.ICdmDataSource, eu.etaxonomy.cdm.common.IProgressMonitor)
-	 */
+	@Override
 	public Integer invoke (ICdmDataSource datasource, IProgressMonitor monitor){
 		boolean result = true;
+		
+		//non audit
+		result &= invokeQueryMap(datasource, queryMap); ;
+		//audit
+		if (this.includeAudit){
+			result &= invokeQueryMap(datasource, auditQueryMap);
+		}else{
+			logger.info("SimpleSchemaUpdaterStep non Audited");
+		}
+		
+		return (result == true )? 0 : null;
+	}
+
+	private boolean invokeQueryMap(ICdmDataSource datasource, Map<DatabaseTypeEnum, String> queryMap) {
+		boolean result = true;
 		String query = queryMap.get(datasource.getDatabaseType());
 		if (query == null){
 			query = queryMap.get(null);
 		}
+		if (query != null){
+			result = executeQuery(datasource, query);
+		}else{
+			//TODO exception ?
+			logger.warn("No query found to execute");
+		}
+		return result;
+	}
+
+	private boolean executeQuery(ICdmDataSource datasource,  String query) {
 		try {
 			datasource.executeUpdate(query);
 		} catch (SQLException e) {
 			logger.error(e);
-			result = false;
+			return false;
 		}
-		return (result == true )? 0 : null;
+		return true;
+	}
+	
+	private void makeAuditedQuery(DatabaseTypeEnum dbType, String tableName){
+		String nonAuditQuery = this.queryMap.get(dbType);
+		if (StringUtils.isBlank(nonAuditQuery)){
+			throw new IllegalArgumentException("Non-audit query must not be blank");
+		}
+		String auditQuery = nonAuditQuery.replace(" " + tableName + " ", " " + tableName + "_AUD ");
+		//TODO warning if nothing changed
+		this.auditQueryMap.put(dbType, auditQuery);
 	}
 
 //********************************* DELEGATES *********************************/
 	
-	public String put(DatabaseTypeEnum dbType, String query) {
-		return queryMap.put(dbType, query);
+	/**
+	 * For certain database types one may define special queries
+	 * @param dbType database type
+	 * @param query query to use for the given database type.
+	 * @return this schema updater step 
+	 */
+	public SimpleSchemaUpdaterStep put(DatabaseTypeEnum dbType, String query) {
+		queryMap.put(dbType, query);
+		return this;
 	}
 
-
+	/**
+	 * Defines the non audited table name for computing the audited query.
+	 * @param nonAuditedTableName
+	 * @return
+	 */
+	public SimpleSchemaUpdaterStep setDefaultAuditing(String nonAuditedTableName){
+		if (StringUtils.isBlank(nonAuditedTableName)){
+			throw new IllegalArgumentException("TableName must not be blank");
+		}
+		this.includeAudit = true;
+		makeAuditedQuery(null, nonAuditedTableName);
+		return this;
+	}
 	
 }
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/SingleTermRemover.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/SingleTermRemover.java
new file mode 100644
index 0000000000..ebd7bb634f
--- /dev/null
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/SingleTermRemover.java
@@ -0,0 +1,137 @@
+// $Id$
+/**
+* Copyright (C) 2009 EDIT
+* European Distributed Institute of Taxonomy 
+* http://www.e-taxonomy.eu
+* 
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+package eu.etaxonomy.cdm.database.update;
+
+import java.sql.ResultSet;
+import java.sql.SQLException;
+import java.util.ArrayList;
+import java.util.List;
+import java.util.UUID;
+
+import org.apache.log4j.Logger;
+
+import eu.etaxonomy.cdm.common.monitor.IProgressMonitor;
+import eu.etaxonomy.cdm.database.ICdmDataSource;
+
+/**
+ * Removes a given term if it is not in use.
+ * TODO does not yet check all DefinedTermBase_XXX tables except for representations.
+ * Does also not handle AUD tables
+ * 
+ * @author a.mueller
+ * @date 06.09.2013
+ *
+ */
+public class SingleTermRemover extends SchemaUpdaterStepBase<SingleTermRemover> implements ITermUpdaterStep{
+	@SuppressWarnings("unused")
+	private static final Logger logger = Logger.getLogger(SingleTermRemover.class);
+	
+	public static final SingleTermRemover NewInstance(String stepName, String uuidTerm, List<String> checkUsedQueries){
+		return new SingleTermRemover(stepName, uuidTerm, checkUsedQueries);	
+	}
+	
+	/**
+	 * @param firstCheckUsedQuery The first query to check if this term is used. Must return a single int value > 0 
+	 * if this term is used at the given place.
+	 * @return
+	 */
+	public static final SingleTermRemover NewInstance(String stepName, String uuidTerm, String firstCheckUsedQuery){
+		List<String> checkUsedQueries = new ArrayList<String>();
+		checkUsedQueries.add(firstCheckUsedQuery);
+		return new SingleTermRemover(stepName, uuidTerm, checkUsedQueries);	
+	}
+	
+	
+	private String uuidTerm ;
+	private List<String> checkUsedQueries = new ArrayList<String>();
+	
+
+	private SingleTermRemover(String stepName, String uuidTerm, List<String> checkUsedQueries) {
+		super(stepName);
+		this.uuidTerm = uuidTerm;
+		this.checkUsedQueries = checkUsedQueries; 
+	}
+
+	@Override
+	public Integer invoke(ICdmDataSource datasource, IProgressMonitor monitor) throws SQLException{
+ 		//get term id
+		String sql = " SELECT id FROM DefinedTermBase WHERE uuid = '%s'";
+		Integer id = (Integer)datasource.getSingleValue(String.format(sql, this.uuidTerm));
+		if (id == null || id == 0){
+			return 0;
+		}
+		
+		//check if in use
+		if (checkTermInUse(datasource, monitor, id)){
+			return 0;
+		}
+		
+		//if not ... remove
+		removeTerm(datasource, monitor, id);
+		
+		return 0;
+	}
+
+	private void removeTerm(ICdmDataSource datasource, IProgressMonitor monitor, int id) throws SQLException {
+		
+		//get representation ids
+		List<Integer> repIDs = new ArrayList<Integer>();
+		getRepIds(datasource, id, repIDs, "representations_id", "DefinedTermBase_Representation" );
+		getRepIds(datasource, id, repIDs, "inverserepresentations_id", "RelationshipTermBase_inverseRepresentation");
+		
+		//remove MN table
+		String sql = " DELETE FROM DefinedTermBase_Representation WHERE DefinedTermBase_id = " + id;
+		datasource.executeUpdate(sql);
+		sql = " DELETE FROM RelationshipTermBase_inverseRepresentation WHERE DefinedTermBase_id = " +id;
+		datasource.executeUpdate(sql);
+		
+		//remove representations
+		for (Integer repId : repIDs){
+			sql = " DELETE FROM Representation WHERE id = " + repId;
+			datasource.executeUpdate(sql);
+		}
+		
+		//remove term
+		sql = " DELETE FROM DefinedTermBase WHERE id = " + id;
+		datasource.executeUpdate(sql);
+	}
+
+	private void getRepIds(ICdmDataSource datasource, int id,
+			List<Integer> repIDs, String mnRepresentationIdAttr, String mnTableName) throws SQLException {
+		String sql = " SELECT DISTINCT %s as repId FROM %s WHERE DefinedTermBase_id = %d";
+		sql = String.format(sql, mnRepresentationIdAttr, mnTableName, id);
+		ResultSet rs = datasource.executeQuery(sql);
+		while (rs.next()){
+			Integer repId = rs.getInt("repId");  //TODO nullSafe, but should not happen
+			if (repId != null){  
+				repIDs.add(repId);
+			}
+		}
+	}
+
+	private boolean checkTermInUse(ICdmDataSource datasource, IProgressMonitor monitor, int id) throws SQLException {
+		for (String query : checkUsedQueries){
+			query = String.format(query, id);
+			Number i = (Number)datasource.getSingleValue(query);
+			if (i != null && (Long)i > 0.0){
+				return true;
+			}
+		}
+		return false;
+	}
+
+	public SingleTermRemover addCheckUsedQuery(String query){
+		this.checkUsedQueries.add(query);
+		return this;
+	}
+	
+
+
+}
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/SingleTermUpdater.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/SingleTermUpdater.java
index e562fb986e..54fb1df6d7 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/SingleTermUpdater.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/SingleTermUpdater.java
@@ -17,7 +17,10 @@ import org.apache.log4j.Logger;
 
 import eu.etaxonomy.cdm.common.monitor.IProgressMonitor;
 import eu.etaxonomy.cdm.database.ICdmDataSource;
+import eu.etaxonomy.cdm.model.common.TermType;
 import eu.etaxonomy.cdm.model.description.Feature;
+import eu.etaxonomy.cdm.model.name.Rank;
+import eu.etaxonomy.cdm.model.name.RankClass;
 
 /**
  * Creates a new term if a term with the same given uuid does not exist yet
@@ -29,9 +32,18 @@ public class SingleTermUpdater extends SchemaUpdaterStepBase<SingleTermUpdater>
 	@SuppressWarnings("unused")
 	private static final Logger logger = Logger.getLogger(SingleTermUpdater.class);
 	
+	/**
+	 * @Deprecated use {@link #NewInstance(String, TermType, UUID, String, String, String, String, UUID, UUID, boolean, UUID)} instead
+	 */
+	@Deprecated
 	public static final SingleTermUpdater NewInstance(String stepName, UUID uuidTerm, String description,  String label, String abbrev, String dtype, UUID uuidVocabulary, UUID uuidLanguage, boolean isOrdered, UUID uuidAfterTerm){
-		return new SingleTermUpdater(stepName, uuidTerm, description, label, abbrev, dtype, uuidVocabulary, uuidLanguage, isOrdered, uuidAfterTerm);	
+		return new SingleTermUpdater(stepName, null, uuidTerm, null, description, label, abbrev, dtype, uuidVocabulary, uuidLanguage, isOrdered, uuidAfterTerm);	
+	}
+
+	public static final SingleTermUpdater NewInstance(String stepName, TermType termType, UUID uuidTerm, String idInVocabulary, String description,  String label, String abbrev, String dtype, UUID uuidVocabulary, UUID uuidLanguage, boolean isOrdered, UUID uuidAfterTerm){
+		return new SingleTermUpdater(stepName, termType, uuidTerm, idInVocabulary, description, label, abbrev, dtype, uuidVocabulary, uuidLanguage, isOrdered, uuidAfterTerm);	
 	}
+
 	
 	private UUID uuidTerm ;
 	private String description;
@@ -45,11 +57,18 @@ public class SingleTermUpdater extends SchemaUpdaterStepBase<SingleTermUpdater>
 	private String reverseDescription;
 	private String reverseLabel;
 	private String reverseAbbrev;
+	private RankClass rankClass;
+	private TermType termType;
+	private String idInVocabulary;
+	private boolean symmetric = false;
+	private boolean transitive = false;
 	
 	
 
-	private SingleTermUpdater(String stepName, UUID uuidTerm, String description, String label, String abbrev, String dtype, UUID uuidVocabulary, UUID uuidLanguage, boolean isOrdered, UUID uuidAfterTerm) {
+	private SingleTermUpdater(String stepName, TermType termType, UUID uuidTerm, String idInVocabulary, String description, String label, String abbrev, String dtype, UUID uuidVocabulary, UUID uuidLanguage, boolean isOrdered, UUID uuidAfterTerm) {
 		super(stepName);
+		this.termType = termType;
+		this.idInVocabulary = idInVocabulary;
 		this.abbrev = abbrev;
 		this.description = description;
 		this.dtype = dtype;
@@ -61,17 +80,13 @@ public class SingleTermUpdater extends SchemaUpdaterStepBase<SingleTermUpdater>
 		this.uuidLanguage = uuidLanguage;
 	}
 
-	
-
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.database.update.SchemaUpdaterStepBase#invoke(eu.etaxonomy.cdm.database.ICdmDataSource, eu.etaxonomy.cdm.common.monitor.IProgressMonitor)
-	 */
+	@Override
 	public Integer invoke(ICdmDataSource datasource, IProgressMonitor monitor) throws SQLException{
  		String sqlCheckTermExists = " SELECT count(*) as n FROM DefinedTermBase WHERE uuid = '" + uuidTerm + "'";
 		Long n = (Long)datasource.getSingleValue(sqlCheckTermExists);
 		if (n != 0){
 			monitor.warning("Term already exists: " + label + "(" + uuidTerm + ")");
-			return null;
+			return -1;
 		}
 		
 		//vocabulary id
@@ -98,7 +113,7 @@ public class SingleTermUpdater extends SchemaUpdaterStepBase<SingleTermUpdater>
 		}
 		
 		String id = Integer.toString(termId);
-		String created = "2010-09-16 10:15:00";
+		String created = getNowString();
 		String defaultColor = "null";
 		String protectedTitleCache = getBoolean(false, datasource);
 		String orderIndex;
@@ -108,11 +123,14 @@ public class SingleTermUpdater extends SchemaUpdaterStepBase<SingleTermUpdater>
 			orderIndex = "null";
 		}
 		String titleCache = label != null ? label : (abbrev != null ? abbrev : description );
-		String sqlInsertTerm = " INSERT INTO DefinedTermBase (DTYPE, id, uuid, created, protectedtitlecache, titleCache, orderindex, defaultcolor, vocabulary_id)" +
-				"VALUES ('" + dtype + "', " + id + ", '" + uuidTerm + "', '" + created + "', " + protectedTitleCache + ", '" + titleCache + "', " + orderIndex + ", " + defaultColor + ", " + vocId + ")"; 
+		String idInVocStr = idInVocabulary == null ? "NULL" : "'" + idInVocabulary + "'";
+		String sqlInsertTerm = " INSERT INTO DefinedTermBase (DTYPE, id, uuid, created, termtype, idInVocabulary, protectedtitlecache, titleCache, orderindex, defaultcolor, vocabulary_id)" +
+				"VALUES ('" + dtype + "', " + id + ", '" + uuidTerm + "', '" + created + "', '" + termType.getKey() + "', " + idInVocStr +  ", " + protectedTitleCache + ", '" + titleCache + "', " + orderIndex + ", " + defaultColor + ", " + vocId + ")"; 
 		datasource.executeUpdate(sqlInsertTerm);
 		
 		updateFeatureTerms(termId, datasource, monitor);
+		updateRelationshipTerms(termId, datasource, monitor);
+		updateRanks(termId, datasource, monitor);
 		
 //
 //		INSERT INTO DefinedTermBase (DTYPE, id, uuid, created, protectedtitlecache, titleCache, orderindex, defaultcolor, vocabulary_id) 
@@ -163,13 +181,11 @@ public class SingleTermUpdater extends SchemaUpdaterStepBase<SingleTermUpdater>
 					" VALUES ("+ termId +"," +reverseRepId+ " )";		
 			
 			datasource.executeUpdate(sqlReverseInsertMN);
-		}
-				
+		}			
 		
 		return termId;
 	}
 
-
 	private void updateFeatureTerms(Integer termId, ICdmDataSource datasource, IProgressMonitor monitor) throws SQLException {
 		if (dtype.equals(Feature.class.getSimpleName())){
 			String sqlUpdate = "UPDATE DefinedTermBase SET " + 
@@ -185,6 +201,29 @@ public class SingleTermUpdater extends SchemaUpdaterStepBase<SingleTermUpdater>
 		}
 	}
 
+	private void updateRelationshipTerms(Integer termId, ICdmDataSource datasource, IProgressMonitor monitor) throws SQLException {
+		if (dtype.contains("Relationship")){
+			String sqlUpdate = "UPDATE DefinedTermBase SET " + 
+				" symmetrical = " + getBoolean(symmetric, datasource) + ", " + 
+				" transitive = " + getBoolean(transitive, datasource) + " " + 
+				" WHERE id = " + termId;
+			datasource.executeUpdate(sqlUpdate);
+		}
+	}
+	
+	private void updateRanks(Integer termId, ICdmDataSource datasource, IProgressMonitor monitor) throws SQLException {
+		if (dtype.equals(Rank.class.getSimpleName())){
+			String sqlUpdate = "UPDATE DefinedTermBase  " + 
+				" SET rankClass = '" + rankClass.getKey() + "'" +  
+				" WHERE id = " + termId;
+			datasource.executeUpdate(sqlUpdate);
+		}
+	}
+	
+	public SingleTermUpdater setRankClass(RankClass rankClass) {
+		this.rankClass = rankClass;
+		return this;
+	}
 
 
 
@@ -211,7 +250,6 @@ public class SingleTermUpdater extends SchemaUpdaterStepBase<SingleTermUpdater>
 		}else{
 			String warning = "The previous term has not been found in vocabulary. Put term to the end";
 			monitor.warning(warning);
-			return "null";
 		}
 		if (intOrderIndex == null){
 			String sqlMaxOrderIndex = " SELECT max(orderindex) FROM DefinedTermBase WHERE vocabulary_id = " + vocId + "";
@@ -221,18 +259,11 @@ public class SingleTermUpdater extends SchemaUpdaterStepBase<SingleTermUpdater>
 			}else{
 				String warning = "No term was found in vocabulary or vocabulary does not exist. Use order index '0'.";
 				monitor.warning(warning);
-				return "0";
+				intOrderIndex =0;
 			}
 		}
 		
 		return intOrderIndex.toString();
-//			-- absence term max orderindex
-//			SELECT (@maxAbsenceOrderIndex := max(orderindex)) AS b FROM DefinedTermBase WHERE DTYPE = 'AbsenceTerm';
-//
-//			-- native reported in error
-//			SELECT (@presenceOrderIndex := orderindex) AS a FROM DefinedTermBase WHERE uuid = '4ba212ef-041e-418d-9d43-2ebb191b61d8';
-//			UPDATE DefinedTermBase SET uuid = '61cee840-801e-41d8-bead-015ad866c2f1', DTYPE = 'AbsenceTerm', vocabulary_id = 18, orderindex = @maxAbsenceOrderIndex + 1 WHERE uuid = '4ba212ef-041e-418d-9d43-2ebb191b61d8';
-//			UPDATE DefinedTermBase SET orderindex = orderindex -1 WHERE DTYPE = 'PresenceTerm' AND orderindex > @presenceOrderIndex ;
 	}
 
 	
@@ -246,6 +277,11 @@ public class SingleTermUpdater extends SchemaUpdaterStepBase<SingleTermUpdater>
 		this.reverseAbbrev = reverseAbbrev;
 		return this;
 	}
-
+	
+	public SingleTermUpdater setSymmetricTransitiv(boolean symmetric, boolean transitive){
+		this.symmetric = symmetric;
+		this.transitive = transitive;
+		return this;
+	}
 
 }
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/SortIndexUpdater.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/SortIndexUpdater.java
new file mode 100644
index 0000000000..03bd7ae36c
--- /dev/null
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/SortIndexUpdater.java
@@ -0,0 +1,159 @@
+// $Id$
+/**
+* Copyright (C) 2009 EDIT
+* European Distributed Institute of Taxonomy 
+* http://www.e-taxonomy.eu
+* 
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+package eu.etaxonomy.cdm.database.update;
+
+import java.sql.ResultSet;
+import java.sql.SQLException;
+import java.util.HashMap;
+import java.util.HashSet;
+import java.util.Map;
+import java.util.Set;
+
+import org.apache.log4j.Logger;
+
+import eu.etaxonomy.cdm.common.monitor.IProgressMonitor;
+import eu.etaxonomy.cdm.database.ICdmDataSource;
+
+/**
+ * @author a.mueller
+ * @date 16.09.2010
+ *
+ */
+public class SortIndexUpdater extends SchemaUpdaterStepBase<SortIndexUpdater> implements ISchemaUpdaterStep {
+	private static final Logger logger = Logger.getLogger(SortIndexUpdater.class);
+	
+	private String tableName;
+	private String sortIndexColumn;
+	private String parentColumn;
+	private String idColumn = "id";
+	private boolean includeAudTable;
+	private Integer baseValue = 0;
+	
+	public static final SortIndexUpdater NewInstance(String stepName, String tableName, String parentColumn, String sortIndexColumn, boolean includeAudTable){
+		return new SortIndexUpdater(stepName, tableName, parentColumn, sortIndexColumn, "id", includeAudTable, 0);
+	}
+
+	public static final SortIndexUpdater NewInstance(String stepName, String tableName, String parentColumn, String sortIndexColumn, String idColumn, boolean includeAudTable){
+		return new SortIndexUpdater(stepName, tableName, parentColumn,sortIndexColumn, idColumn, includeAudTable, 0);
+	}
+
+	
+	protected SortIndexUpdater(String stepName, String tableName, String parentColumn, String sortIndexColumn, String idColumn, boolean includeAudTable, Integer baseValue) {
+		super(stepName);
+		this.tableName = tableName;
+		this.parentColumn = parentColumn;
+		this.sortIndexColumn = sortIndexColumn;
+		this.idColumn = idColumn;
+		this.includeAudTable = includeAudTable;
+		this.baseValue = baseValue;
+	}
+
+	@Override
+	public Integer invoke(ICdmDataSource datasource, IProgressMonitor monitor) throws SQLException {
+		boolean result = true;
+		result &= addColumn(tableName, datasource, monitor);
+		if (includeAudTable){
+			String aud = "_AUD";
+			result &= addColumn(tableName + aud, datasource, monitor);
+		}
+		return (result == true )? 0 : null;
+	}
+
+	private boolean addColumn(String tableName, ICdmDataSource datasource, IProgressMonitor monitor) throws SQLException {
+		
+		Map<Integer, Set<Integer>> indexMap = makeIndexMap(datasource);
+		
+		updateIndices(tableName, datasource, indexMap);
+		
+		return true;
+	}
+
+	/**
+	 * @param datasource 
+	 * @param rs
+	 * @param index
+	 * @param oldParentId
+	 * @return
+	 * @throws SQLException
+	 */
+	private Map<Integer, Set<Integer>> makeIndexMap(ICdmDataSource datasource) throws SQLException {
+		String resulsetQuery = "SELECT @id as id, @parentColumn " +
+				" FROM @tableName " +
+				" WHERE @parentColumn IS NOT NULL " + 
+				" ORDER BY @parentColumn,    @id";
+		resulsetQuery = resulsetQuery.replace("@tableName", tableName);
+		resulsetQuery = resulsetQuery.replace("@parentColumn", parentColumn);
+		resulsetQuery = resulsetQuery.replace("@id", idColumn);
+
+		ResultSet rs = datasource.executeQuery(resulsetQuery);
+		Integer index = baseValue;
+		int oldParentId = -1;
+		
+		
+		//increase index with each row, set to 0 if parent is not the same as the previous one
+		Map<Integer, Set<Integer>> indexMap = new HashMap<Integer, Set<Integer>>(); 
+		while (rs.next() ){
+			int id = rs.getInt("id");
+			Object oParentId = rs.getObject(parentColumn);
+			if (oParentId != null){
+				int parentId = Integer.valueOf(oParentId.toString());
+				if (oldParentId != parentId){
+					index = baseValue;
+					oldParentId = parentId;
+				}else{
+					index++;
+				}
+				putIndex(id, index, indexMap);
+			}else{
+				logger.warn("This should not happen");
+				index = baseValue;
+			}
+//			System.out.println(oParentId + "," + id+","+ index+";");
+		}
+		return indexMap;
+	}
+
+	private void updateIndices(String tableName, ICdmDataSource datasource, Map<Integer, Set<Integer>> indexMap)
+			throws SQLException {
+		for (Integer index :  indexMap.keySet()){
+			Set<Integer> set = indexMap.get(index);
+			String idSetString = makeIdSetString(set);
+			
+			String updateQuery = "UPDATE @tableName SET @sortIndexColumn = @index WHERE @id IN (@idList) ";
+			updateQuery = updateQuery.replace("@tableName", tableName);
+			updateQuery = updateQuery.replace("@sortIndexColumn", sortIndexColumn);
+			updateQuery = updateQuery.replace("@index", index.toString());
+			updateQuery = updateQuery.replace("@idList", idSetString);
+			updateQuery = updateQuery.replace("@id", idColumn);
+			datasource.executeUpdate(updateQuery);
+		}
+	}
+
+	private static String makeIdSetString(Set<Integer> set) {
+		StringBuffer result = new StringBuffer(set.size() * 5);
+		for (Integer id:set){
+			result.append(id + ",");
+		}
+		return result.substring(0, result.length() - 1);
+	}
+
+	/**
+	 * Adds the id to the index (each id is attached to an (sort)index) 
+	 */
+	private void putIndex(Integer id, Integer index, Map<Integer, Set<Integer>> indexMap) {
+		Set<Integer> set = indexMap.get(index);
+		if (set == null){
+			set = new HashSet<Integer>();
+			indexMap.put(index, set);
+		}
+		set.add(id);
+	}
+
+}
